/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <stdio.h>
#include <E/collection.h>
#include "IntBtree.h"


void IntBtIndex::insert(int val, dbvoid* ref)
{
    index.insert(val,ref);
}


// member function to look up a record in a hashed file based on its key value
dbvoid* IntBtIndex::lookup(int val)
{
    dbvoid * ret_ptr;
    btree_retrieve<int> look_scan(index,val);
    // this is dubious
    for (look_scan.next(); !look_scan.eof; look_scan.next())
    {
      return look_scan.cur_elem;
    }
    return 0;
}

// member function to delete a record in a hashed file based on its key value
// returns pointer to object contained in the deleted bucket
dbvoid* IntBtIndex::remove(int val)
{
    btree_retrieve<int> rem_scan(index,val);
    // this is dubious
    int numvals = 0;
    dbvoid *ret_ptr = 0;
    for (rem_scan.next(); !rem_scan.eof; rem_scan.next())
    {
       ret_ptr = rem_scan.cur_elem;
       index.remove(rem_scan.cur_keyval, rem_scan.cur_elem);
       return ret_ptr;
    }
    return 0;
}
